local HC = require 'lib.hardoncollider'
local Player = require 'player'

local width, height = love.graphics.getDimensions()

local Game = {}

local function on_collide(dt, shape_a, shape_b, mtv_x, mtv_y) -- mtv is 'minimum translation vector' needed to resolve the collision
	local other

	if shape_a == Game.player.shape then
		other = shape_b
		shape_a:move(mtv_x, mtv_y)
		print('AAAAAAAAAAAAAAA')
	elseif shape_b == Game.player.shape then
		other = shape_a
		shape_b:move(mtv_x, mtv_y)
		print('BBBBBBBBBB')
	else
		return
	end

	if other == Game.enemy then
		print('enemy')
	end

	print('bump')
	
	--Game.player.shape:move(mtv_x, mtv_y)
	Game.player.speed = 0	
end

function Game:init()
	-- create new collision detection instance, pass in callback functions
	-- arg1 is the cell size for internal search structure
	self.collider = HC(100, on_collide, collision_stop)

	self.player = Player(self.collider)

	self.border = 
	{
		top    = self.collider:addRectangle(100,100 - 10, 600,10),
		bottom = self.collider:addRectangle(100,500, 600,10),
		left     = self.collider:addRectangle(100 - 10,100, 10,400),
		right    = self.collider:addRectangle(700,100, 10,400)
	}
	-- group walls and inactivate them for performance
	for _,shape in pairs(self.border) do
		self.collider:addToGroup("walls", shape)
		self.collider:setPassive(shape)
	end

	self.enemy = self.collider:addCircle(400,400, 16)
end

function Game:update(dt)
	self.player:update(dt)

	-- check for collisions
	self.collider:update(dt)
end

function Game:draw()
	love.graphics.setBackgroundColor(175,220,255)

	for _,shape in pairs(self.border) do
		shape:draw('fill')
	end
	
	self.player:draw()
	love.graphics.setColor(255,255,255)
	self.enemy:draw('fill')
end

return Game